/**
 * 删除好友
 */

(() => {
    let node_util;
    let db_util;
    let app_util;
    let log_util;
    /**
     * 控件id
     */
    let ids;
    /**
     * 控件文本
     */
    let texts;
    let language;
    let running_config;
    /**
     * 好友备注
     */
    let last_friend_remark;
    /**
     * 好友的微信号
     */
    let last_we_chat_id;
    /**
     * 上一次点击的可见好友的位置
     */
    let last_index;
    let count_wait_delete_friend;
    /**
     * 运行状态
     */
    let run;
    let stuck;
    let accumulator;

    function findContactsNode() {
        let node = idMatches(ids["contacts"]).textMatches(texts["contacts"]).findOne(running_config["find_delay_duration"]);
        if (!node) {
            log_util.warn("通讯录控件id可能不一致");
        }
        return node;
    }

    /**
     * 点击通讯录
     */
    function clickContacts() {
        while (true) {
            let node = findContactsNode();
            if (running_config["delete_friends"]["clickContacts"]["widget"]) {
                if (node_util.backtrackClickNode(node)) {
                    log_util.debug("控件点击通讯录成功");
                    break;
                }
                log_util.error("控件点击通讯录失败");
            }
            if (running_config["delete_friends"]["clickContacts"]["coordinate"]) {
                if (node_util.backtrackSimulationClickNode(node)) {
                    log_util.debug("坐标点击通讯录成功");
                    break;
                }
                log_util.error("坐标点击通讯录失败");
            }
        }
        return clickFriend;
    }

    /**
     * 点击好友
     */
    function clickFriend() {
        let friend_remark_nodes, friend_list_node = idMatches(ids["friend_list"]).visibleToUser(true).findOne(running_config["find_delay_duration"]);
        if (friend_list_node) {
            friend_remark_nodes = friend_list_node.find(idMatches(ids["friend_remark"]));
        } else {
            friend_remark_nodes = idMatches(ids["friend_remark"]).visibleToUser(true).find();
            log_util.warn("联系人列表控件id可能不一致");
        }
        if (!friend_remark_nodes.size()) {
            log_util.warn("好友备注控件id可能不一致");
        }
        while (last_index < friend_remark_nodes.size()) {
            last_friend_remark = friend_remark_nodes.get(last_index).text();
            if (db_util.isSelectedFriendForDeleteByFriendRemark(last_friend_remark)) {
                break;
            }
            last_index++;
        }
        if (last_index >= friend_remark_nodes.size()) {
            let node = idMatches(ids["contacts_count"]).findOnce();
            if (!node) {
                log_util.warn("好友数量控件id可能不一致");
            }
            return node ? stopScript : scrollFriendList;
        }
        while (true) {
            if (running_config["delete_friends"]["clickFriend"]["widget"]) {
                if (node_util.backtrackClickNode(friend_remark_nodes.get(last_index))) {
                    log_util.debug("控件点击联系人成功");
                    break;
                }
                log_util.error("控件点击联系人失败");
            }
            if (running_config["delete_friends"]["clickFriend"]["coordinate"]) {
                if (node_util.backtrackSimulationClickNode(friend_remark_nodes.get(last_index))) {
                    log_util.debug("坐标点击联系人成功");
                    break;
                }
                log_util.error("坐标点击联系人失败");
            }
        }
        last_index++;
        return checkWeChatId;
    }

    /**
    * 检查微信号是否相同
    */
    function checkWeChatId() {
        if (!idMatches(ids["more_function_by_delete"]).findOne(running_config["find_delay_duration"])) {
            log_util.trace("忽略联系人");
            return backToFriendList;
        }
        let we_chat_id_node = idMatches(ids["we_chat_id"]).findOne(running_config["find_delay_duration"]);
        if (we_chat_id_node) {
            last_we_chat_id = we_chat_id_node.text();
            if (db_util.isSelectedFriendForDeleteByWeChatID(last_we_chat_id)) {
                return clickMoreFunction;
            }
            return backToFriendList;
        }
        log_util.warn("微信号控件id可能不一致");
        return scrollFriendDetailsPage;
    }

    /**
     * 滚动联系人详情页
     */
    function scrollFriendDetailsPage() {
        while (true) {
            if (running_config["delete_friends"]["scrollFriendDetailsPage"]["widget"]) {
                // 控件滚动联系人详情页
                let node = idMatches(ids["friend_details_page_list"]).findOne(running_config["find_delay_duration"]);
                if (node) {
                    if (node.bounds().left == node.bounds().right) {
                        log_util.warn("联系人详情页控件宽度为0");
                    }
                    if (node_util.scrollForward(node)) {
                        log_util.debug("控件滚动联系人详情页成功");
                        break;
                    }
                    log_util.error("控件滚动联系人详情页失败");
                } else {
                    log_util.warn("联系人详情页控件id可能不一致");
                }
            }
            if (running_config["delete_friends"]["scrollFriendDetailsPage"]["coordinate"]) {
                // 坐标滚动联系人详情页
                setScreenMetrics(1080, 1920);
                if (swipe(540, 1658, 540, 428, running_config["click_delay_duration"])) {
                    log_util.debug("坐标滚动联系人详情页成功");
                    break;
                }
                log_util.error("坐标滚动联系人详情页失败");
            }
        }
        return checkWeChatId;
    }

    /**
     * 点击更多功能
     */
    function clickMoreFunction() {
        while (true) {
            let node = idMatches(ids["more_function_by_delete"]).findOne(running_config["find_delay_duration"]);
            if (running_config["delete_friends"]["clickMoreFunction"]["widget"]) {
                if (node_util.backtrackClickNode(node)) {
                    log_util.debug("控件点击更多功能成功");
                    break;
                }
                log_util.error("控件点击更多功能失败");
            }
            if (running_config["delete_friends"]["clickMoreFunction"]["coordinate"]) {
                if (node_util.backtrackSimulationClickNode(node)) {
                    log_util.debug("坐标点击更多功能成功");
                    break;
                }
                log_util.error("坐标点击更多功能失败");
            }
            log_util.warn("更多功能控件id可能不一致");
        }
        return clickDeleteFunction;
    }

    /**
     * 点击删除功能
     */
    function clickDeleteFunction() {
        let node = idMatches(ids["delete"]).textMatches(texts["delete"]).findOne(running_config["find_delay_duration"]);
        while (node) {
            if (running_config["delete_friends"]["clickDeleteFunction"]["widget"]) {
                if (node_util.backtrackClickNode(node)) {
                    log_util.debug("控件点击删除功能成功");
                    return clickConfirmDelete;
                }
                log_util.error("控件点击删除功能失败");
            }
            if (running_config["delete_friends"]["clickDeleteFunction"]["coordinate"]) {
                if (node_util.backtrackSimulationClickNode(node)) {
                    log_util.debug("坐标点击删除功能成功");
                    return clickConfirmDelete;
                }
                log_util.error("坐标点击删除功能失败");
            }
        }
        log_util.warn("删除功能控件id可能不一致");
        return scrollMoreFunctionPage;
    }

    /**
     * 点击确认删除
     */
    function clickConfirmDelete() {
        while (true) {
            let node = idMatches(ids["confirm_delete"]).findOne(running_config["find_delay_duration"]);
            if (running_config["delete_friends"]["clickConfirmDelete"]["widget"]) {
                if (node_util.backtrackClickNode(node)) {
                    log_util.debug("控件点击删除成功");
                    break;
                }
                log_util.error("控件点击删除失败");
            }
            if (running_config["delete_friends"]["clickConfirmDelete"]["coordinate"]) {
                if (node_util.backtrackSimulationClickNode(node)) {
                    log_util.debug("坐标点击删除成功");
                    break;
                }
                log_util.error("坐标点击删除失败");
            }
            log_util.warn("确认删除控件id可能不一致");
        }
        last_index--;
        db_util.modifyTestedFriend({ we_chat_id: last_we_chat_id, deleted: true });
        db_util.deleteLabelFriendByFriendRemark(last_friend_remark);
        log_util.info("---------------更多功能页面---------------");
        return --count_wait_delete_friend ? clickFriend : stopScript;
    }

    /**
     * 滚动更多功能页面
     */
    function scrollMoreFunctionPage() {
        while (true) {
            if (running_config["delete_friends"]["scrollMoreFunctionPage"]["widget"]) {
                // 控件滚动更多功能页面
                let node = idMatches(ids["more_function_by_delete_list"]).findOne(running_config["find_delay_duration"]);
                if (node) {
                    if (node.bounds().left == node.bounds().right) {
                        log_util.warn("更多功能页面控件宽度为0");
                    }
                    if (node_util.scrollForward(node)) {
                        log_util.debug("控件滚动更多功能页面成功");
                        break;
                    }
                    log_util.error("控件滚动更多功能页面失败");
                } else {
                    log_util.warn("更多功能页面控件id可能不一致");
                }
            }
            if (running_config["delete_friends"]["scrollMoreFunctionPage"]["coordinate"]) {
                // 坐标滚动更多功能页面
                setScreenMetrics(1080, 1920);
                if (swipe(540, 1658, 540, 428, running_config["click_delay_duration"])) {
                    log_util.debug("坐标滚动更多功能页面成功");
                    break;
                }
                log_util.error("坐标滚动更多功能页面失败");
            }
        }
        return clickDeleteFunction;
    }

    /**
     * 返回好友列表
     */
    function backToFriendList() {
        while (true) {
            let node = idMatches(ids["back_to_friend_list"]).findOne(running_config["find_delay_duration"]);
            if (running_config["delete_friends"]["backToFriendList"]["widget"]) {
                if (node_util.backtrackClickNode(node)) {
                    log_util.debug("控件点击返回好友列表成功");
                    break;
                }
                log_util.error("控件点击返回好友列表失败");
            }
            if (running_config["delete_friends"]["backToFriendList"]["coordinate"]) {
                if (node_util.backtrackSimulationClickNode(node)) {
                    log_util.debug("坐标点击返回好友列表成功");
                    break;
                }
                log_util.error("坐标点击返回好友列表失败");
            }
            log_util.warn("返回好友列表控件id可能不一致");
        }
        return clickFriend;
    }

    /**
     * 滚动好友列表
     */
    function scrollFriendList() {
        while (true) {
            if (running_config["delete_friends"]["scrollFriendList"]["widget"]) {
                // 控件滚动联系人列表
                let node = idMatches(ids["friend_list"]).findOne(running_config["find_delay_duration"]);
                if (node) {
                    if (node.bounds().left == node.bounds().right) {
                        log_util.warn("联系人列表控件宽度为0");
                    }
                    if (node_util.scrollForward(node)) {
                        log_util.debug("控件滚动联系人列表成功");
                        break;
                    }
                    log_util.error("控件滚动联系人列表失败");
                } else {
                    log_util.warn("联系人列表控件id可能不一致");
                }
            }
            if (running_config["delete_friends"]["scrollFriendList"]["coordinate"]) {
                // 坐标滚动联系人列表
                setScreenMetrics(1080, 1920);
                if (swipe(540, 1658, 540, 428, running_config["click_delay_duration"])) {
                    log_util.debug("坐标滚动联系人列表成功");
                    break;
                }
                log_util.error("坐标滚动联系人列表失败");
            }
        }
        last_index = 0;
        log_util.info("---------------好友列表页面---------------");
        return clickFriend;
    }

    /**
     * 监听音量下键按下，停止脚本运行
     */
    function keyDownListenerByVolumeDown() {
        threads.start(function () {
            // 启用按键监听
            events.observeKey();
            events.setKeyInterceptionEnabled("volume_down", true);
            // 监听减音量键按下
            events.onceKeyDown("volume_down", () => {
                stopScript();
            });
        });
    }

    /**
     * 累计器监听器
     */
    function accumulatorListener() {
        threads.start(function () {
            let localAccumulator = 0;
            setInterval(() => {
                if (localAccumulator == accumulator) {
                    stuck = true;
                    stopScript();
                }
                localAccumulator = accumulator;
            }, running_config["accumulator_delay_duration"]);
        });
    }

    /**
     * 停止脚本运行
     */
    function stopScript() {
        run = false;
        device.cancelKeepingAwake();
        events.removeAllListeners();
        threads.shutDownAll();
        toast(language["script_stopped"]);
        log_util.info("---------------结束删除好友---------------");
        if (stuck && running_config["reboot_script"]) {
            engines.execScriptFile(engines.myEngine().getSource().toString());
        } else {
            engines.execScriptFile("main.js");
        }
        engines.myEngine().forceStop();
    }

    function main() {
        node_util = require("utils/node_util.js");
        db_util = require("utils/db_util.js");
        log_util = require("utils/log_util.js");
        app_util = require("utils/app_util.js");

        language = app_util.getLanguage();
        running_config = app_util.getRunningConfig();
        ids = app_util.getWeChatIds();
        texts = app_util.getWeChatTexts();

        last_index = 0, run = true, accumulator = 0;

        let delete_friends = {};
        for (let method of running_config["delete_friends"]) {
            delete_friends[method["function_name"]] = method;
        }
        running_config["delete_friends"] = delete_friends;

        keyDownListenerByVolumeDown();
        accumulatorListener();
        device.keepScreenDim();

        toast(language["script_running"]);
        log_util.info("---------------开始删除好友---------------");

        // 确保在微信首页
        let we_chat_package_name = app_util.getConfig()["we_chat_package_name"];
        launch(we_chat_package_name);
        waitForPackage(we_chat_package_name);
        while (!findContactsNode()) {
            back();
            if (currentPackage() == we_chat_package_name) {
                accumulator++;
            }
        }

        /**
         * 此方式流程控制较为灵活
         */
        count_wait_delete_friend = db_util.countWaitDeleteFriend();
        for (let nextFunction = clickContacts; run && nextFunction; nextFunction = nextFunction()) {
            accumulator++;
            let method = running_config["delete_friends"][nextFunction.name];
            if (method && method["delay"]) {
                sleep(running_config["click_delay_duration"])
            }
        }
    }

    main();
})();